import axios from "axios";
import NProgress from "nprogress";
import { Message } from 'element-ui';
import { getCookie } from "./storage";
const cancelToken = axios.CancelToken;
let axiosRequestList = [];
let messageNotice = null;
NProgress.configure({
  easing: "ease",
  speed: 500,
  showSpinner: true
});

axios.defaults["baseURL"] = process.env.NODE_ENV != "development" ? process.env.VUE_APP_BASE_API : '';
axios.defaults["timeout"] = process.env.VUE_APP_TIMEOUT;
axios.defaults["crossDomain"] = true;
axios.defaults["withCredentials"] = true;
axios.defaults["method"] = "post";
axios.defaults.headers.common["Accept-Language"] = "zh-cn";

axios.interceptors.request.use(req, reqError);
axios.interceptors.response.use(res, resError);

let removePending = (config) => {
  for (let i in axiosRequestList) {
    if (axiosRequestList[i].url === axios.defaults.baseURL + config.url) {
      axiosRequestList[i].cancel();
      axiosRequestList.splice(i, 1);
    }
  }
}
let removeRequestList = (config) => {
  NProgress.done();
  let key = config.url + '-' + config.method;
  delete axiosRequestList[key];
}
function req(config) {
  // removePending(config);
  // config.cancelToken = new cancelToken(function executor(c) {
  //   axiosRequestList.push({
  //     url: axios.defaults.baseURL + config.url,
  //     cancel: c
  //   });
  // });
  NProgress.start();
  config.headers["token"] = getCookie('token') || '';
  return config;
}
function reqError(err) {
  console.log('req', err);
  console.log('reqError:', err);
  return;
}
function res(res) {
  let { data, config } = res;
  // removeRequestList(config);
  if (data.code === 200) return res;
  messageNotice && messageNotice.close();
  messageNotice = Message.error(data.message);
  return Promise.reject(res);
}
function resError(err) {
  console.log('resError:', err);
  // removeRequestList(err.config);
  return Promise.reject(err);
}

export const getAxiosRequest = () => {
  return axiosRequestList;
};
export default axios;
